# Class SSAOPipeline

This class sets up the postprocess pipeline for achieving the SSAO effect First, the current screen is written to a buffer (screenBlit) Secondly, SSAO for the current screen is calculated using the depth buffer Thirdly, the contents of the SSAO post process, which is what is currently bound to the screen is blurred first horizontally and then the blurred result is further blurred vertically Lastly the SSAO buffer is used to darken the color of the screen buffer

#### Implements

- TwinfinityCameraBehavior

##### Index

### Constructors

constructor

### Accessors

samplesCount
strength

### Methods

attach
detach

## Constructors

### constructor

- new SSAOPipeline(
  samplesCount: undefined | number,
  strength: undefined | number,
  blurSize: undefined | number,
  radius: undefined | number,
  renderScale: undefined | number,
  ): SSAOPipeline

  #### Parameters

  - samplesCount: undefined | number
  - strength: undefined | number
  - blurSize: undefined | number
  - radius: undefined | number
  - renderScale: undefined | number

  #### Returns SSAOPipeline

## Accessors

### samplesCount

- get samplesCount(): number

  #### Returns number

- set samplesCount(samples: number): void

  #### Parameters

  - samples: number

  #### Returns void

### strength

- get strength(): number

  #### Returns number

- set strength(strength: number): void

  #### Parameters

  - strength: number

  #### Returns void

## Methods

### attach

- attach(camera: Camera): boolean

  Attaches this behavior to the specified camera.

  #### Parameters

  - camera: Camera

    The camera to attach the behavior to.

  #### Returns boolean

  true if the behavior was successfully attached to the camera, otherwise false.

  Implementation of TwinfinityCameraBehavior.attach

### detach

- detach(camera: Camera): boolean

  Detaches this behavior from the specified camera.

  #### Parameters

  - camera: Camera

    The camera to detach this behavior from.

  #### Returns boolean

  true if the behavior was successfully detached from the camera, otherwise false.

  Implementation of TwinfinityCameraBehavior.detach